#ifndef VEC3F_H
#define VEC3F_H

#include <iostream> 	// std::{cout, endl, etc.}
#include <cmath> 	// std::{sqrt, abs, etc.}
#include <stdexcept>	// std::out_of_range exception

class Vec3f
{
public:
	explicit Vec3f( float x = 0, float y = 0, float z = 0 );

	Vec3f & operator = ( const Vec3f & other ); // assignment operator

	// Getter/Setter
	float x() const;
	void x( float x );
	float y() const;
	void y( float y );
	float z() const;
	void z( float z );

	float operator[]( int idx ) const;
	float & operator[]( int idx );

	// Usefull Member Functions
	
	float length() const;
	float lengthSquared() const;
	float dotProduct( Vec3f const & other ) const;
		
	// Usefull Member Operators
	Vec3f operator * ( float factor ) const;
	Vec3f operator + ( const Vec3f & other ) const;	
	Vec3f operator - ( const Vec3f & other ) const;
	
	// TODO
	/*
	Vec3f normalized() const;
	void normalize();
	float distance( Vec3f const & other ) const;
	Vec3f crossProduct( Vec3f const & other ) const;
	Vec3f projectOnto( Vec3f const & other ) const;
	*/

	// TODO if you want
	//void operator += ( const Vec3f & other );
	//void operator -= ( const Vec3f & other );
	//void operator *= ( float factor );

private:
	float m_x, m_y, m_z;
};

// So you can do std::cout << vec << std::endl;
std::ostream & operator<<( std::ostream & out, Vec3f const & vec );

#endif // Vec3f
